package com.sd.business.mapper.board;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.sd.business.entity.board.vo.*;
import org.apache.ibatis.annotations.Param;

/**
 * <p>
 * 销售看板 Mapper 接口
 * </p>
 *
 * @author
 * @since 2023-11-17
 */
public interface SalesBoardMapper {

    /**
     * 获取sku销量排名列表分页
     * @param page
     * @param wrapper
     * @return
     */
    Page<SkuSalesRankingVo> getSkuSalesRankingPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<SkuSalesRankingVo> wrapper);

    /**
     * 获取sku销售额排名列表分页
     * @param page
     * @param wrapper
     * @return
     */
    Page<SkuSalesAmountRankingVo> getSkuSalesAmountRankingPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<SkuSalesAmountRankingVo> wrapper);

    /**
     * 获取bom销量排名列表分页
     * @param page
     * @param wrapper
     * @return
     */
    Page<BomSalesRankingVo> getBomSalesRankingPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<BomSalesRankingVo> wrapper);


    /**
     * 获取bom销售额排名列表分页
     * @param page
     * @param wrapper
     * @return
     */
    Page<BomSalesAmountRankingVo> getBomSalesAmountRankingPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<BomSalesAmountRankingVo> wrapper);

    /**
     * 获取sku销售地区排名列表分页
     * @param page
     * @param wrapper
     * @return
     */
    Page<SkuSalesRegionRankingVo> getSkuSalesRegionRankingPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<SkuSalesRegionRankingVo> wrapper);

    /**
     * 获取sku销量增长率排名列表分页
     * @param page
     * @param wrapper
     * @return
     */
    Page<SkuSalesGrowthRateRankingVo> getSkuSalesGrowthRateRankingPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<SkuSalesGrowthRateRankingVo> wrapper);
}
